<template>
  <div class="md-layout md-gutter md-alignment-center">
    <div v-if="posts.length === 0" class="busy-indicator-posts d-flex align-items-center">
      <md-progress-spinner :md-diameter="110" :md-stroke="8" md-mode="indeterminate"></md-progress-spinner>
    </div>
    <div
      v-else
      class="md-layout-item md-large-size-33 md-medium-size-50 md-small-size-100 md-xsmall-size-100 custom-card-item"
      v-for="(post, index) in posts"
      v-bind:item="post"
      v-bind:index="index"
      v-bind:key="post._id"
    >
      <md-card class="card" md-with-hover>
        <md-card-area md-inset>
          <md-card-header>
            <md-avatar>
              <img v-if="post.user.avatar" :src="post.user.avatar" alt="Avatar" />
            </md-avatar>
            <div class="profile-name">
              <div class="md-title" v-if="post.user">{{ post.user.name }}</div>
              <div class="md-subhead">Subtitle here</div>
            </div>
          </md-card-header>
          <md-card-media class="custom-card-media">
            <img :src="post.content.image" alt="image" />
          </md-card-media>

          <md-card-content>{{ post.content.text }}</md-card-content>
        </md-card-area>
        <md-card-expand>
          <md-card-actions>
            <div class="post-date">
              <md-icon>date_range</md-icon>
              <p>
                {{
                `${post.createdAt.getDate()}/${post.createdAt.getMonth() +
                1}/${post.createdAt.getFullYear()}`
                }}
              </p>
            </div>
            <div class="spinner-like-container">
              <md-tooltip md-direction="top" class="users-likes">
                <div
                  class="user-name"
                  v-for="user in post.content.likes"
                  :key="user.id"
                >{{ user.name }}</div>
              </md-tooltip>
              <p
                v-if="postIndex !== index && post.content.likes.length"
              >Likes: {{ post.content.likes.length }}</p>
              <md-progress-spinner
                v-if="
                postIndex === index &&
                  choosedPosts.map(
                    post => post.likeItemId && post.likeItemId.id === post.id
                  )[0]
              "
                :md-diameter="20"
                :md-stroke="3"
                md-mode="indeterminate"
              ></md-progress-spinner>
            </div>
            <md-button
              :class="{
              'md-accent': post.content.likes.find(
                item => item.id === user.userId
              )
            }"
              class="md-icon-button"
              @click="
              likePost({
                id: post._id,
                userData: { id: user.userId, name: user.name },
                index: index
              })
            "
            >
              <md-icon>thumb_up</md-icon>
            </md-button>
            <md-button
              v-if="post.user.userId === user.userId"
              class="md-icon-button"
              @click="deletePost({ id: post._id, index: index })"
            >
              <md-icon>delete</md-icon>
            </md-button>
            <md-card-expand-trigger>
              <md-button class="md-icon-button">
                <md-icon>keyboard_arrow_down</md-icon>
              </md-button>
            </md-card-expand-trigger>
          </md-card-actions>
          <md-card-expand-content>
            <md-card-content>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio itaque ea, nostrum odio. Dolores, sed accusantium quasi non, voluptas eius illo quas, saepe voluptate pariatur in deleniti minus sint. Excepturi.</md-card-content>
          </md-card-expand-content>
        </md-card-expand>
        <div
          class="busy-indicator"
          v-if="
            postIndex === index &&
              choosedPosts.map(
                post => post.deleteItemId && post.deleteItemId.id === post.id
              )[0]
          "
        >
          <div class="d-flex align-items-center">
            <md-progress-spinner :md-diameter="90" :md-stroke="6" md-mode="indeterminate"></md-progress-spinner>
          </div>
        </div>
      </md-card>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState, mapGetters, mapMutations } from "vuex";
export default {
  name: "Post",
  props: ["posts"],

  computed: {
    ...mapGetters(["user", "isLoggedIn"]),
    ...mapState(["postIndex", "showLikeSpinner", "choosedPosts"])
  },

  methods: {
    ...mapActions([
      "deletePostAndFetchData",
      "likePostAndFetchData",
      "getProfile"
    ]),

    ...mapMutations(["toggleShowModal", "updateLikedOnlyPosts"]),

    likePost(id, userData, index) {
      if (this.isLoggedIn) {
        this.likePostAndFetchData(id, userData, index).then(updatedLikes => {
          this.updateLikedOnlyPosts({
            postId: id.id,
            updatedLikes: updatedLikes.data
          });
        });
      } else {
        this.toggleShowModal("redirectLogin");
      }
    },

    deletePost(id, index) {
      if (this.isLoggedIn) this.deletePostAndFetchData(id, index);
      else this.toggleShowModal("redirectLogin");
    }
  },
  async created() {
    if (this.isLoggedIn) await this.getProfile();
  }
};
</script>

<style lang="scss">
.md-tooltip.md-theme-default {
  height: auto;
  white-space: pre;
  .user-name {
    padding: 1px 5px 0 5px;
    font-size: 11px;
    &:first-of-type {
      margin-top: 5px;
    }
    &:last-of-type {
      margin-bottom: 5px;
    }
  }
}

.custom-card-item {
  min-width: 425px;
  max-width: 425px;
}

.custom-card-media {
  position: relative;
  overflow: hidden;
  max-height: 243px;
}

.card {
  margin-bottom: 35px;
  position: relative;

  .md-avatar {
    position: absolute;
    left: 15px;
    img {
      height: auto;
      width: 100%;
    }
  }

  .md-card-header {
    display: flex;
    align-items: center;
    justify-content: center;
  }

  .profile-name {
    padding-left: 50px;
    padding-right: 50px;
    .md-title {
      font-size: 18px;
      font-weight: 500;
      letter-spacing: 0.005em;
      line-height: 26px;
    }
    .md-subhead {
      padding-left: 0;
    }
  }

  .busy-indicator {
    top: 0;
    left: 0;
    position: absolute;
    background-color: rgba(0, 0, 0, 0.4);
    height: 100%;
    width: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
  }
}
.post-date {
  margin-left: 10px;
  margin-right: auto;
  display: flex;
  align-items: center;
  p {
    margin-left: 7px;
    line-height: 13px;
  }
}
.spinner-like-container {
  margin-right: 10px;
  min-width: 80px;
  text-align: center;
  display: flex;
  height: 24px;
  justify-content: center;
  line-height: 0;
  align-items: center;
  position: relative;
  p {
    line-height: normal;
    position: absolute;
    top: 4px;
    margin: 0;
  }
}
@media (max-width: 1536px) {
  .custom-card-media {
    max-height: 193px;
  }
}
</style>
